package io.tswf.groovy.bettergroovy.asm.transmutation.annotation;

import io.tswf.groovy.bettergroovy.asm.transmutation.meta.MissingTargetStrategy;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface Transmute {
    ClassReference targetClass() default @ClassReference;
    MethodDescription targetMethod() default @MethodDescription(name = "");
    MissingTargetStrategy onMissing() default MissingTargetStrategy.WARNING;
    At[] at() default {};
    DependedAt[] dependedAt() default {};
}
