package io.tswf.groovy.bettergroovy.asm.transmutation.injection

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.missing.TransmutationMissingTargetHandler
import io.tswf.groovy.bettergroovy.asm.transmutation.meta.TransmutationMethodMetadata
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class TransmutationTargetMethodsFinder {

    static MethodNode findMatchingTargetMethodForTransmutation(TransmutationMethodMetadata transmutationMeta, ClassNode targetClass) {
        def targetMethodDesc = transmutationMeta.targetMethodDescription
        def matchingMethod = targetClass.methods.find { it.name == targetMethodDesc.name && it.desc == targetMethodDesc.descriptor }

        if (matchingMethod == null) {
            matchingMethod = TransmutationMissingTargetHandler.handleMissingTargetAndTryToPass(transmutationMeta, targetClass)
        }

        return matchingMethod
    }
}
