package io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.ITransmutationPreInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.contexts.TransmutationInjectionToMethodAtInsnContext
import org.objectweb.asm.tree.VarInsnNode

import static org.objectweb.asm.Opcodes.*
import static io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.DefaultHookConstants.*

@CompileStatic
class StoreThrownExceptionPreInjectionHook implements ITransmutationPreInjectionHook {

    @Override
    void handleTransmutationPreInjection(TransmutationInjectionToMethodAtInsnContext context) {
        if (context.startInsn.opcode == ATHROW) {
            def targetMethod = context.allPointsContext.targetMethod
            def thrownExceptionLocalVarId = context.allPointsContext.customPayload.computeIfAbsent(THROWN_EXCEPTION_LOCAL_VAR_KEY) {
                targetMethod.createNewLocal(Throwable, "thrownException", true)
            }

            context.customPayload.putByKey(NEEDS_TO_LOAD_THROWN_EXCEPTION_LOCAL_VAR_KEY, true)
            context.insnsToInsertToCurrent << new VarInsnNode(ASTORE, thrownExceptionLocalVarId)
        }
    }
}
