package io.tswf.groovy.bettergroovy.asm.transmutation.injection.points

import groovy.transform.CompileStatic
import org.objectweb.asm.Opcodes
import org.objectweb.asm.tree.AbstractInsnNode
import org.objectweb.asm.tree.InsnNode

@CompileStatic
abstract class AbstractInsnTransmutationInjectionPoint implements ITransmutationInjectionPoint, Opcodes {

    Set<Integer> insns

    AbstractInsnTransmutationInjectionPoint(Collection<Integer> insns) {
        this.insns = insns.toSet()
    }

    @Override
    AbstractInsnNode findNextNodeNearInject(InjectionPointSearchContext context) {
        def insnCandidate = context.insnFromSearch
        while (insnCandidate != null) {
            if (insnCandidate instanceof InsnNode) {
                if (insnCandidate.opcode in insns || isInsnValidCustom(insnCandidate.opcode, context))
                    return insnCandidate
            }

            insnCandidate = insnCandidate.next
        }

        return null
    }

    boolean isInsnValidCustom(int insn, InjectionPointSearchContext context) {
        return false
    }
}
