package io.tswf.groovy.bettergroovy.asm.transmutation.injection.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtExit

@AutoService(ITransmutationInjectionPoint)
@CompileStatic
class ExitTransmutationInjectionPoint extends AbstractInsnTransmutationInjectionPoint {

    ExitTransmutationInjectionPoint() {
        super([ ATHROW ])
    }

    @Override
    boolean isInsnValidCustom(int insn, InjectionPointSearchContext context) {
        return context.transmutationTargetMethodNode.returnType.getOpcode(IRETURN) == insn
    }
}
