package io.tswf.groovy.bettergroovy.asm.transmutation.injection.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtReturn

@AutoService(ITransmutationInjectionPoint)
@CompileStatic
class ReturnTransmutationInjectionPoint extends AbstractInsnTransmutationInjectionPoint {

    ReturnTransmutationInjectionPoint() {
        super([])
    }

    @Override
    boolean isInsnValidCustom(int insn, InjectionPointSearchContext context) {
        return context.transmutationTargetMethodNode.returnType.getOpcode(IRETURN) == insn
    }
}
