package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningConstantIfTrue
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningValueIfNotNull
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.returnvalue.ReturnConstantIfTransmutationTrueReturnValueProcessor
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.returnvalue.ReturnObjectIfNotNullReturnValueProcessor
import io.tswf.groovy.bettergroovy.asm.transmutation.util.ConstantUtil
import org.objectweb.asm.tree.AnnotationNode

@AutoService(IReturnValueProcessorReader)
@CompileStatic
class ReturningConstantIfTrueProcessorReader implements IReturnValueProcessorReader {

    @Override
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext) {
        def requestedConstant = readingContext.transmutationMetadata.transmutationMethod
                .findAnnotationByType(ReturningConstantIfTrue)
                ?.getValueByName("value", AnnotationNode)
                ?.with {
                    ConstantUtil.getConstantFromAnnotation(it)
                }

        if (requestedConstant != null) {
            readingContext.readedProcessors << new ReturnConstantIfTransmutationTrueReturnValueProcessor(requestedConstant)
        }
    }
}
