package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningValueIfNotNull
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.returnvalue.ReturnObjectIfNotNullReturnValueProcessor

@AutoService(IReturnValueProcessorReader)
@CompileStatic
class ReturningValueIfNotNullProcessorReader implements IReturnValueProcessorReader {

    @Override
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasAnnotation(ReturningValueIfNotNull)) {
            readingContext.readedProcessors << new ReturnObjectIfNotNullReturnValueProcessor()
        }
    }
}
