package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Self
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.parameter.SelfCustomParameterLoader

@AutoService(ICustomParameterLoaderReader)
@CompileStatic
class SelfCustomParameterLoaderReader implements ICustomParameterLoaderReader {

    @Override
    void handleLoaderSearch(CustomParameterLoaderReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasParameterAnnotation(readingContext.parameterIndex, Self)) {
            readingContext.transmutationMetadata.customParameterLoaders << new SelfCustomParameterLoader()
            readingContext.completed = true
        }
    }
}
