package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.hook

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturnedValue
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningValueIfNotNull
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.LoadReturnValuePostInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.StoreReturnValuePreInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IPostInjectionHooksReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IPreInjectionHooksReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.PostInjectionHooksReadingContext
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.PreInjectionHooksReadingContext

@AutoService(IPostInjectionHooksReader)
@CompileStatic
class LoadReturnValueOnReturnValueParameterReader implements IPostInjectionHooksReader {

    @Override
    void handlePostInjectionHooksReading(PostInjectionHooksReadingContext readingContext) {
        def transmutationMethod = readingContext.transmutationMetadata.transmutationMethod
        if (transmutationMethod.hasAnnotationOnAnyParameter(ReturnedValue) && !readingContext.transmutationMetadata.preInjectionHooks.any { it instanceof LoadReturnValuePostInjectionHook }) {
            readingContext.transmutationMetadata.postInjectionHooks.add(new LoadReturnValuePostInjectionHook())
        }
    }
}
