package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.hook

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ThrownException
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.LoadReturnValuePostInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.LoadThrownExceptionPostInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IPostInjectionHooksReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.PostInjectionHooksReadingContext

@AutoService(IPostInjectionHooksReader)
@CompileStatic
class LoadThrownExceptionOnThrownExceptionParameterReader implements IPostInjectionHooksReader {

    @Override
    void handlePostInjectionHooksReading(PostInjectionHooksReadingContext readingContext) {
        def transmutationMethod = readingContext.transmutationMetadata.transmutationMethod
        if (transmutationMethod.hasAnnotationOnAnyParameter(ThrownException) && !readingContext.transmutationMetadata.preInjectionHooks.any { it instanceof LoadReturnValuePostInjectionHook }) {
            readingContext.transmutationMetadata.postInjectionHooks.add(new LoadThrownExceptionPostInjectionHook())
        }
    }
}
