package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.hook

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturnedValue
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningValueIfNotNull
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.StoreReturnValuePreInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IPreInjectionHooksReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.PreInjectionHooksReadingContext

@AutoService(IPreInjectionHooksReader)
@CompileStatic
class StoreReturnValueOnReturnValueParameterPassed implements IPreInjectionHooksReader {

    @Override
    void handlePreInjectionHooksReading(PreInjectionHooksReadingContext readingContext) {
        def transmutationMethod = readingContext.transmutationMetadata.transmutationMethod
        if (transmutationMethod.hasAnnotationOnAnyParameter(ReturnedValue) && !readingContext.transmutationMetadata.preInjectionHooks.any { it instanceof StoreReturnValuePreInjectionHook }) {
            readingContext.transmutationMetadata.preInjectionHooks.add(new StoreReturnValuePreInjectionHook())
        }
    }
}
