package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.hook

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ThrownException
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.hook.StoreThrownExceptionPreInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IPreInjectionHooksReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.PreInjectionHooksReadingContext

@AutoService(IPreInjectionHooksReader)
@CompileStatic
class StoreThrownExceptionOnThrownExceptionParameterReader implements IPreInjectionHooksReader {

    @Override
    void handlePreInjectionHooksReading(PreInjectionHooksReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasAnnotationOnAnyParameter(ThrownException)) {
            readingContext.transmutationMetadata.preInjectionHooks << new StoreThrownExceptionPreInjectionHook()
        }
    }
}
