package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtExit
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.points.ExitTransmutationInjectionPoint
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IInjectionPointReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.InjectionPointReadingContext

@AutoService(IInjectionPointReader)
@CompileStatic
class ExitTransmutationInjectionPointReader implements IInjectionPointReader {

    @Override
    void handleInjectionPointReading(InjectionPointReadingContext context) {
        context.result = new ExitTransmutationInjectionPoint()
    }

    @Override
    Class getMarkerAnnotationClass() {
        return AtExit
    }
}
