package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtHead
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.points.MethodHeadTransmutationInjectionPoint
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IInjectionPointReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.InjectionPointReadingContext

@AutoService(IInjectionPointReader)
@CompileStatic
class MethodHeadTransmutationInjectionPointReader implements IInjectionPointReader {

    @Override
    void handleInjectionPointReading(InjectionPointReadingContext context) {
        context.result = new MethodHeadTransmutationInjectionPoint()
    }

    @Override
    Class getMarkerAnnotationClass() {
        return AtHead
    }
}
