package io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtReturn
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.points.ReturnTransmutationInjectionPoint
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.IInjectionPointReader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.reader.InjectionPointReadingContext

@AutoService(IInjectionPointReader)
@CompileStatic
class ReturnTransmutationInjectionPointReader implements IInjectionPointReader {

    @Override
    void handleInjectionPointReading(InjectionPointReadingContext context) {
        context.result = new ReturnTransmutationInjectionPoint()
    }

    @Override
    Class getMarkerAnnotationClass() {
        return AtReturn
    }
}
