package io.tswf.groovy.bettergroovy.asm.transmutation.injection.returnvalue

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.exception.InvalidTransmutationException
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.contexts.TransmutationInjectionToMethodAtInsnContext
import org.objectweb.asm.Type
import org.objectweb.asm.tree.InsnNode
import org.objectweb.asm.tree.MethodNode

import static org.objectweb.asm.Opcodes.RETURN

@CompileStatic
class ReturnVoidIfTransmutationTrueReturnValueProcessor extends AbstractIfTrueTransmutationTrueReturnValueProcessor {

    @Override
    void validateTarget(MethodNode targetMethod) {
        def targetMethodReturnType = targetMethod.returnType
        if (targetMethodReturnType != Type.VOID_TYPE) {
            throw new InvalidTransmutationException("Can't return void type from non-void method ${targetMethod.javaFullName}. Was: ${targetMethodReturnType.className}!")
        }
    }

    @Override
    void addReturnInsns(TransmutationInjectionToMethodAtInsnContext context) {
        context.insnsToInsertToCurrent << new InsnNode(RETURN)
    }
}
