package io.tswf.groovy.bettergroovy.asm.transmutation.meta

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.ITransmutationMethodCustomParameterLoader
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.ITransmutationMethodReturnValueProcessor
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.ITransmutationPostInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.ITransmutationPreInjectionHook
import io.tswf.groovy.bettergroovy.asm.transmutation.util.CustomPayload
import io.tswf.groovy.bettergroovy.asm.transmutation.util.ICustomPayload
import org.objectweb.asm.Type
import org.objectweb.asm.commons.Method as AsmMethod
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class TransmutationMethodMetadata {
    ClassNode transmutationOwner
    MethodNode transmutationMethod
    AsmMethod targetMethodDescription
    Type targetClass
    ITransmutationMethodReturnValueProcessor returnValueProcessor

    MissingTargetStrategy targetMissingStrategy = MissingTargetStrategy.WARNING
    ICustomPayload customPayload = new CustomPayload()

    List<ITransmutationMethodCustomParameterLoader> customParameterLoaders = new ArrayList<>()
    List<ITransmutationPostInjectionHook> postInjectionHooks = new ArrayList<>()
    List<ITransmutationPreInjectionHook> preInjectionHooks = new ArrayList<>()

    List<TransmutationMethodInjectionPointMetadata> injectionPoints = new ArrayList<>()
}

@CompileStatic
enum TransmutationBodyLocation {
    TRANSMUTATION_CONTAINER,
    TARGET_CLASS_BODY
}

@CompileStatic
enum MissingTargetStrategy {
    WARNING,
    CREATE_NEW,
    THROW,
    SKIP
}
