package io.tswf.groovy.bettergroovy.asm.transmutation.util

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.meta.TransmutationMethodInjectionPointMetadata
import org.objectweb.asm.tree.AnnotationNode

@CompileStatic
class DependAtUtil {

    static TransmutationMethodInjectionPointMetadata getDependInjectionPointMetadataFromAnnotation(AnnotationNode annotationNode) {
        def injectionPointsAts = annotationNode.getValueByName("value", AnnotationNode[])
        def injectionPointMetadataList = injectionPointsAts.map { AtUtil.getInjectionPointMetadataFromAnnotation(it) }
        injectionPointMetadataList.reverse(true)

        if (injectionPointMetadataList.isEmpty()) {
            throw new RuntimeException()
        }

        def iterator = injectionPointMetadataList.iterator()
        def next = iterator.next()

        while (iterator.hasNext()) {
            def newNext = iterator.next()
            if (newNext != null) {
                next.parent = newNext
            }
            next = newNext
        }

        return injectionPointMetadataList.first()
    }
}
