package io.tswf.groovy.bettergroovy.asm.transmutation.util

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.exception.TransmutationInjectionOffsetException
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.contexts.InjectionOffset
import org.objectweb.asm.tree.AbstractInsnNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class InjectionInsnOffsetUtil {

    static AbstractInsnNode applyInsnOffset(MethodNode method, AbstractInsnNode node, InjectionOffset offset) {
        if (offset == InjectionOffset.BEFORE && node.previous != null) {
            return node.previous
        }

        if (offset == InjectionOffset.NO && node != null) {
            return node
        }

        if (node.next != null) {
            return node.next
        }

        throw new TransmutationInjectionOffsetException("There is no next instruction for '${node}' in ${method.javaFullName}! Please, choose another offset, not a ${offset.name()}!")
    }
}
